;nyquist plug-in
;version 4
;type analyze
;name "wSNR v24"
;debugbutton false
;author "Ulf Elman"
;release 2.3.1-1
$copyright (_ "GNU General Public License v2.0 or later")

;Det här är en sammanslagning av InUtToningBort18 och wSNR v10
;240413
;Fungerar för filer kortare än 6-7s
;Fel (inget resultat) för filer kortare än ...s
;Kraschar Audacity vid 56min
;Filter anpassade för 44,1 48 96 382ksps. Bör varna om annan frekvens

;(snd-set-max-audio-mem 2000000000)
;Initialt typ 1GB. Verkar inte vara en lösning för långa inspelningar

;Ett stort tack för hjälp med översättningarna till
;Fabien Hanocq (Français)
;Jacobo Ramil Millarengo (Español)
;Karsten Kathol (Deutsch)
;Mikhail Velikanov (Русский)
;Niels Krabbe (Dansk)
;Stein Ørjan Nilsen (Norsk)
;Hans Matheve (Nederlands)

(setf *locale*
  '(("en" (("Intoning bortklippt" "Fade in removed")
           ("SNR" "SNR")
           ("dB" "dB")
           ("Ljudkvalitet" "Sound quality")
           ("Uttoning bortklippt" "Fade out removed")
           ("Pauser med tystnad mitt i filen" "Silent pauses mid file")
           ("Ta bort innan mätning" "Remove before measuring")
           ("Lågt SNR uppmätt" "Low SNR detected")
           ("Tät ljudbild identifierad" "Dense soundscape detected")
           ("Bandpassfilterbaserad mätning" "Bandpass filter set based SNR assessment")
           ("Signal överstyrd" "Signal clipped")))
    ("de" (("Intoning bortklippt" "Einblenden entfernt:")
           ("SNR" "SNR")
           ("dB" "dB")
           ("Ljudkvalitet" "Tonqualität")
           ("Uttoning bortklippt" "Ausblenden entfernt:")
           ("Pauser med tystnad mitt i filen" "Stille Pausen mitten in der Datei")
           ("Ta bort innan mätning" "Vor dem Messen entfernen")))
    ("es" (("Intoning bortklippt" "Eliminado aparecer progresivamente")
           ("SNR" "SNR")
           ("dB" "dB")
           ("Ljudkvalitet" "Calidad del sonido")
           ("Uttoning bortklippt" "Eliminado desvanecer")
           ("Pauser med tystnad mitt i filen" "Pausas en silencio en mitad del archivo")
           ("Ta bort innan mätning" "Eliminar antes de medir")
           ("Lågt SNR uppmätt" "Detectada una baja Relación Señal-Ruído ")
           ("Tät ljudbild identifierad" "Detectado  paisaje sonoro denso")
           ("Bandpassfilterbaserad mätning" "Usado un filtro de Paso de Banda")))
    ("da" (("Intoning bortklippt" "Fade-in fjernet")
           ("SNR" "SNR")
           ("dB" "dB")
           ("Ljudkvalitet" "Lydkvalitet")
           ("Uttoning bortklippt" "Fade-out fjernet")
           ("Pauser med tystnad mitt i filen" "Lydløse pauser midt i filen")
           ("Ta bort innan mätning" "Fjern før måling")
           ("Lågt SNR uppmätt" "Lav SNR (lyd/støjratio) registreret")
           ("Tät ljudbild identifierad" "Tæt lydbillede registreret")
           ("Bandpassfilterbaserad mätning" "Båndbreddefilter anvendt")))
    ("nl" (("Intoning bortklippt" "Fade-in verwijderd")
           ("SNR" "SNR")
           ("dB" "dB")
           ("Ljudkvalitet" "Geluidskwaliteit")
           ("Uttoning bortklippt" "Fade-out verwijderd")
           ("Pauser med tystnad mitt i filen" "Stilte-pauzes middenin het bestand")
           ("Ta bort innan mätning" "Verwijder vóór het meten")
           ("Lågt SNR uppmätt" "Lage signaal-ruisverhouding (SNR) gemeten")
           ("Tät ljudbild identifierad" "Druk klankschap gedetecteerd")
           ("Signal överstyrd" "Signaal overschreden")
           ("Spektralt randig inspelning. Gräshoppor spelar sannolikt" "Spectraal 'gestreepte' opname. Vermoedelijk vocaliserende Orthoptera (sprinkhaan/kreke)l")
           ("Bandpassfilterbaserad mätning" "Op banddoorlaat-filter gebaseerde signaal-ruisverhouding (SNR) meting")))
    ("fr" (("Intoning bortklippt" "Fondu en ouverture retiré")
           ("SNR" "SNR")
           ("dB" "dB")
           ("Ljudkvalitet" "Qualité du son")
           ("Uttoning bortklippt" "Fondu en fermeture retiré")
           ("Pauser med tystnad mitt i filen" "Pauses silencieuses à l'intérieur de l'enregistrement")
           ("Ta bort innan mätning" "A retirer avant de mesurer")
           ("Lågt SNR uppmätt" "Faible SNR détecté")
           ("Tät ljudbild identifierad" "Paysage sonore dense détecté")
           ("Bandpassfilterbaserad mätning" "SNR évalué à partir d'un jeu de filtres passe-bande")
           ("Inspelningen överstyrd" "Signal écrêté")))
    ("nb" (("Intoning bortklippt" "Inntoning bortklippet")
           ("SNR" "SNR")
           ("dB" "dB")
           ("Ljudkvalitet" "Lydkvalitet")
           ("Uttoning bortklippt" "Uttoning bortklippet")
           ("Pauser med tystnad mitt i filen" "Pauser med stillhet midt i filen")
           ("Ta bort innan mätning" "Fjern dette innen måling")
           ("Lågt SNR uppmätt" "Lavt SNR funnet")
           ("Tät ljudbild identifierad" "Tett lydbilde identifisert")
           ("Bandpassfilterbaserad mätning" "Måling basert på bandpasfilter")))
    ("sv" (("Intoning bortklippt" "Intoning bortklippt")
           ("SNR" "SNR")
           ("dB" "dB")
           ("Ljudkvalitet" "Ljudkvalitet")
           ("Uttoning bortklippt" "Uttoning bortklippt")
           ("Pauser med tystnad mitt i filen" "Pauser med tystnad mitt i filen")
           ("Ta bort innan mätning" "Ta bort innan mätning")))
    ("ru" (("Intoning bortklippt" "Плавное нарастание звука удалено")
           ("SNR" "Отношение сигнал/шум")
           ("dB" "дБ")
           ("Ljudkvalitet" "Качество звука")
           ("Uttoning bortklippt" "Плавное затухание звука удалено")
           ("Pauser med tystnad mitt i filen" "Запись содержит паузы (периоды тишины)")
           ("Ta bort innan mätning" "Удалите их перед повторным вычислением")
           ("Lågt SNR uppmätt" "Низкое значение отношения сигнал/шум")
           ("Tät ljudbild identifierad" "Высокая плотность сигнала, уровень шума невозможно определить")
           ("Bandpassfilterbaserad mätning" "Использован метод на основе системы полосовых фильтров")
           ("max" "max")
))))

(setq originalstarttid (get '*selection* 'start))
(setq originalsluttid (get '*selection* 'end))
(setq originallength (- originalsluttid originalstarttid))
(setq starttid originalstarttid)
(setq sluttid originalsluttid)

; NotSNRcalcPluginV3.ny använder rate=80 Hz, window-size=0.05 s.
;Här används rate=100 Hz, window-size=0.005(!)s @ 48ksps.

(defun number-to-string (number)
  (format nil "~a" number))

(defun rmsminB (ljud)
   (setq minirms (rms ljud 100 240))
   (if (arrayp minirms)
      (setq antalsamples (snd-length (aref minirms 0) 100000000))
      (setq antalsamples (snd-length minirms 100000000))
   )
   (setq minst 99)
   (while (> antalsamples 0)
      (setq rmsA  (multichan-expand #'snd-fetch minirms))
      (if (arrayp rmsA)
         (setq rmsB (s-sqrt (/ (+ (mult (aref rmsA 0) (aref rmsA 0)) (mult (aref rmsA 1) (aref rmsA 1))  ) 2 )))      
         ;(setq rmsB (aref rmsA 0))
         (setq rmsB rmsA)
      )
      (setq minst (min minst rmsB))
      (setq antalsamples (- antalsamples 1))
   )
   (setq rmsminB minst)
)


(defun rmsmin (ljud)
   (setq minirms (rms ljud 40 2400))
   ; (rms ljud 100 240)) i InUtToningBort16
   (if (arrayp minirms)
      (setq antalsamples (snd-length (aref minirms 0) 100000000))
      (setq antalsamples (snd-length minirms 100000000))
   )
   (setq minst 99)
;   Utelämna det sista rmsvärdet, för det kan tydligen vara lite konstigt
   (while (> antalsamples 1)
      (setq rmsA  (multichan-expand #'snd-fetch minirms))
      (if (arrayp rmsA)
         (setq rmsB (s-sqrt (/ (+ (mult (aref rmsA 0) (aref rmsA 0)) (mult (aref rmsA 1) (aref rmsA 1))  ) 2 )))      
         ;(setq rmsB (aref rmsA 0))
         (setq rmsB rmsA)
      )
      (setq minst (min minst rmsB))
      (setq antalsamples (- antalsamples 1))
   )
   (setq rmsmin minst)
)


(defun rmsmax (ljud)
   (setq minirms (rms ljud 40 2400))
   (if (arrayp minirms)
      (setq antalsamples (snd-length (aref minirms 0) 100000000))
      (setq antalsamples (snd-length minirms 100000000))
   )
   (setq biggest 0)
   (while (> antalsamples 0)
      (setq rmsA  (multichan-expand #'snd-fetch minirms))
      (if (arrayp rmsA)
         (setq rmsB (s-sqrt (/ (+ (mult (aref rmsA 0) (aref rmsA 0)) (mult (aref rmsA 1) (aref rmsA 1))  ) 2 )))      
         ;(setq rmsB (aref rmsA 0))
         (setq rmsB rmsA)
      )
      (setq biggest (max biggest rmsB))
      (setq antalsamples (- antalsamples 1))
   )
   (setq rmsmax biggest)
)

(defun amplitudmax (ljud)
   ;(setq minirms (rms ljud 40 2400))
   (if (arrayp ljud)
      (setq antalsamples (snd-length (aref ljud 0) 100000000))
      (setq antalsamples (snd-length ljud 100000000))
   )
   (setq biggest 0)
   (while (> antalsamples 0)
      (setq amplitud  (multichan-expand #'snd-fetch ljud))
      (if (arrayp amplitud)
         (setq amplitudB (s-sqrt (/ (+ (mult (aref amplitud 0) (aref amplitud 0)) (mult (aref amplitud 1) (aref amplitud 1))  ) 2 )))      
         ;(setq rmsB (aref rmsA 0))
         (setq amplitudB (abs amplitud))
      )
      (setq biggest (max biggest amplitudB))
      (setq antalsamples (- antalsamples 1))
   )
   (setq amplitudmax biggest)
)

(defun amplitudmax2 (ljud)
      (if (arrayp ljud)
         (progn
            (setq amplitudmax2left (peak (aref ljud 0) 100000000))
            (setq amplitudmax2right (peak (aref ljud 1) 100000000))
            (setq amplitudmax2 (max amplitudmax2left amplitudmax2right))
         )
         (setq amplitudmax2 (peak ljud 100000000))
      )
)

;Högpassfiltret 8 ger ändtransienter
;(setq toningsurval (highpass8 *track* 100))
(setq toningsurval (hp *track* 100))
; Utan högpassfilter ger DC och LP-störningar problem 
;(setq toningsurval *track*)

(if (> originallength 15)
   (setq urvalmitt (multichan-expand #'multichan-expand #'extract-abs  (+  originalstarttid 5) (-  originalsluttid 5)  toningsurval))
   (if (> originallength 8)
      (setq urvalmitt (multichan-expand #'extract-abs  (+  originalstarttid 2) (-  originalsluttid 2)  toningsurval))
      (if (> originallength 5)
         (setq urvalmitt (multichan-expand #'extract-abs  (+  originalstarttid 1) (-  originalsluttid 1)  toningsurval))
         (if (> originallength 2)         
         (setq urvalmitt (multichan-expand #'extract-abs  (+  originalstarttid 0.5) (-  originalsluttid 0.5)  toningsurval))
         (setq urvalmitt (multichan-expand #'extract-abs  (+  originalstarttid 0.3) (-  originalsluttid 0.3)  toningsurval))
         )
      )
   )
)

;(if (> originallength 3)
;   (progn
;      (setq urvalglapp (multichan-expand #'extract-abs  (+  originalstarttid 1) (-  originalsluttid 1)  toningsurval))
;      (setq rmsurvalglapp (linear-to-db (rmsminB urvalglapp)))
;      (if (< rmsurvalglapp -80) (setq glapp 1) (setq glapp 0))
;   )
;   (setq glapp 2)
;)

; Under -80dB rimligt om filen är normaliserad, annars inte
(setq glapplimit -90)
(if (> originallength 15)
   (progn
      (setq urvalglapp (multichan-expand #'multichan-expand #'extract-abs  (+  originalstarttid 5) (-  originalsluttid 5)  toningsurval))
      (setq rmsurvalglapp (linear-to-db (rmsminB urvalglapp)))
      (if (< rmsurvalglapp glapplimit) (setq glapp 1) (setq glapp 0))
   )
   (if (> originallength 8)
      (progn
      (setq urvalglapp (multichan-expand #'extract-abs  (+  originalstarttid 2) (-  originalsluttid 2)  toningsurval))
      (setq rmsurvalglapp (linear-to-db (rmsminB urvalglapp)))
      (if (< rmsurvalglapp glapplimit) (setq glapp 1) (setq glapp 0))
      )
      (if (> originallength 5)
         (progn
         (setq urvalglapp (multichan-expand #'extract-abs  (+  originalstarttid 1) (-  originalsluttid 1)  toningsurval))
         (setq rmsurvalglapp (linear-to-db (rmsminB urvalglapp)))
         (if (< rmsurvalglapp glapplimit) (setq glapp 1) (setq glapp 0))
         )
         (if (> originallength 2)
            (progn   
            (setq urvalglapp (multichan-expand #'extract-abs  (+  originalstarttid 0.5) (-  originalsluttid 0.5)  toningsurval))
            (setq rmsurvalglapp (linear-to-db (rmsminB urvalglapp)))
            (if (< rmsurvalglapp glapplimit) (setq glapp 1) (setq glapp 0))
         )
            (setq glapp 2)
         )
      )
   )
)


(if (> originallength 15) (setq urvalstartB (multichan-expand #'extract-abs  (+  originalstarttid 4.0) (+  originalstarttid 5.0)  toningsurval)))
(if (> originallength 15) (setq urvalstartA (multichan-expand #'extract-abs  (+  originalstarttid 3.0) (+  originalstarttid 4.0)  toningsurval)))
(if (> originallength 15) (setq urvalstart1 (multichan-expand #'extract-abs  (+  originalstarttid 2.5) (+  originalstarttid 3.0)  toningsurval)))
(if (> originallength 15) (setq urvalstart2 (multichan-expand #'extract-abs  (+  originalstarttid 2.0) (+  originalstarttid 2.5)  toningsurval)))
(if (> originallength 8) (setq urvalstart3 (multichan-expand #'extract-abs  (+  originalstarttid 1.5) (+  originalstarttid 2.0)  toningsurval)))
(if (> originallength 8) (setq urvalstart4 (multichan-expand #'extract-abs  (+  originalstarttid 1.25) (+  originalstarttid 1.5)  toningsurval)))
(if (> originallength 8) (setq urvalstart45 (multichan-expand #'extract-abs  (+  originalstarttid 1.0) (+  originalstarttid 1.25)  toningsurval)))
(if (> originallength 5) (setq urvalstart5 (multichan-expand #'extract-abs  (+  originalstarttid 0.75) (+  originalstarttid 1.0)  toningsurval)))
(if (> originallength 5) (setq urvalstart6 (multichan-expand #'extract-abs  (+  originalstarttid 0.50) (+  originalstarttid 0.75)  toningsurval)))
(if (> originallength 2) (setq urvalstart7 (multichan-expand #'extract-abs  (+  originalstarttid 0.40) (+  originalstarttid 0.50)  toningsurval)))
(if (> originallength 2) (setq urvalstart73 (multichan-expand #'extract-abs  (+  originalstarttid 0.30) (+  originalstarttid 0.40)  toningsurval)))
(setq urvalstart76 (multichan-expand #'extract-abs  (+  originalstarttid 0.20) (+  originalstarttid 0.30)  toningsurval))
(setq urvalstart8 (multichan-expand #'extract-abs  (+  originalstarttid 0.10) (+  originalstarttid 0.20)  toningsurval))
(setq urvalstart9 (multichan-expand #'extract-abs  originalstarttid (+  originalstarttid 0.10)  toningsurval))

(if (> originallength 15) (setq urvalslutB (multichan-expand #'extract-abs  (-  originalsluttid 5.00) (-  originalsluttid 4.00)  toningsurval)))
(if (> originallength 15) (setq urvalslutA (multichan-expand #'extract-abs  (-  originalsluttid 4.00) (-  originalsluttid 3.00)  toningsurval)))
(if (> originallength 15) (setq urvalslut1 (multichan-expand #'extract-abs  (-  originalsluttid 3.00) (-  originalsluttid 2.50)  toningsurval)))
(if (> originallength 15) (setq urvalslut2 (multichan-expand #'extract-abs  (-  originalsluttid 2.50) (-  originalsluttid 2.00)  toningsurval)))
(if (> originallength 8) (setq urvalslut3 (multichan-expand #'extract-abs  (-  originalsluttid 2.00) (-  originalsluttid 1.50)  toningsurval)))
(if (> originallength 8) (setq urvalslut4 (multichan-expand #'extract-abs  (-  originalsluttid 1.50) (-  originalsluttid 1.25)  toningsurval)))
(if (> originallength 8) (setq urvalslut45 (multichan-expand #'extract-abs  (-  originalsluttid 1.25) (-  originalsluttid 1.00)  toningsurval)))
(if (> originallength 5) (setq urvalslut5 (multichan-expand #'extract-abs  (-  originalsluttid 1.00) (-  originalsluttid 0.75)  toningsurval)))
(if (> originallength 5) (setq urvalslut6 (multichan-expand #'extract-abs  (-  originalsluttid 0.75) (-  originalsluttid 0.50)  toningsurval)))
(if (> originallength 2) (setq urvalslut7 (multichan-expand #'extract-abs  (-  originalsluttid 0.50) (-  originalsluttid 0.40)  toningsurval)))
(if (> originallength 2) (setq urvalslut73 (multichan-expand #'extract-abs  (-  originalsluttid 0.40) (-  originalsluttid 0.30)  toningsurval)))
(setq urvalslut76 (multichan-expand #'extract-abs  (-  originalsluttid 0.30) (-  originalsluttid 0.20)  toningsurval))
(setq urvalslut8 (multichan-expand #'extract-abs  (-  originalsluttid 0.20) (-  originalsluttid 0.10)  toningsurval))
(setq urvalslut9 (multichan-expand #'extract-abs  (-  originalsluttid 0.10) originalsluttid  toningsurval))

(setq rmsAdBmitt (linear-to-db (rmsminB urvalmitt)))

(if (> originallength 15) (setq rmsAdBstartB (linear-to-db (rmsminB urvalstartB))) (setq rmsAdBstartB rmsAdBmitt))
(if (> originallength 15) (setq rmsAdBstartA (linear-to-db (rmsminB urvalstartA))) (setq rmsAdBstartA rmsAdBmitt))
(if (> originallength 15) (setq rmsAdBstart1 (linear-to-db (rmsminB urvalstart1))) (setq rmsAdBstart1 rmsAdBmitt))
(if (> originallength 15) (setq rmsAdBstart2 (linear-to-db (rmsminB urvalstart2))) (setq rmsAdBstart2 rmsAdBmitt))
(if (> originallength 8) (setq rmsAdBstart3 (linear-to-db (rmsminB urvalstart3))) (setq rmsAdBstart3 rmsAdBmitt))
(if (> originallength 8) (setq rmsAdBstart4 (linear-to-db (rmsminB urvalstart4))) (setq rmsAdBstart4 rmsAdBmitt))
(if (> originallength 8) (setq rmsAdBstart45 (linear-to-db (rmsminB urvalstart45))) (setq rmsAdBstart45 rmsAdBmitt))
(if (> originallength 5) (setq rmsAdBstart5 (linear-to-db (rmsminB urvalstart5))) (setq rmsAdBstart5 rmsAdBmitt))
(if (> originallength 5) (setq rmsAdBstart6 (linear-to-db (rmsminB urvalstart6))) (setq rmsAdBstart6 rmsAdBmitt))
(if (> originallength 2) (setq rmsAdBstart7 (linear-to-db (rmsminB urvalstart7))) (setq rmsAdBstart7 rmsAdBmitt))
(if (> originallength 2) (setq rmsAdBstart73 (linear-to-db (rmsminB urvalstart73))) (setq rmsAdBstart73 rmsAdBmitt))
(setq rmsAdBstart76 (linear-to-db (rmsminB urvalstart76)))
(setq rmsAdBstart8 (linear-to-db (rmsminB urvalstart8)))
(setq rmsAdBstart9 (linear-to-db (rmsminB urvalstart9)))

(if (> originallength 15) (setq rmsAdBslutB (linear-to-db (rmsminB urvalslutB))) (setq rmsAdBslutB rmsAdBmitt))
(if (> originallength 15) (setq rmsAdBslutA (linear-to-db (rmsminB urvalslutA))) (setq rmsAdBslutA rmsAdBmitt))
(if (> originallength 15) (setq rmsAdBslut1 (linear-to-db (rmsminB urvalslut1))) (setq rmsAdBslut1 rmsAdBmitt))
(if (> originallength 15) (setq rmsAdBslut2 (linear-to-db (rmsminB urvalslut2))) (setq rmsAdBslut2 rmsAdBmitt))
(if (> originallength 8) (setq rmsAdBslut3 (linear-to-db (rmsminB urvalslut3))) (setq rmsAdBslut3 rmsAdBmitt))
(if (> originallength 8) (setq rmsAdBslut4 (linear-to-db (rmsminB urvalslut4))) (setq rmsAdBslut4 rmsAdBmitt))
(if (> originallength 8) (setq rmsAdBslut45 (linear-to-db (rmsminB urvalslut45))) (setq rmsAdBslut45 rmsAdBmitt))
(if (> originallength 5) (setq rmsAdBslut5 (linear-to-db (rmsminB urvalslut5))) (setq rmsAdBslut5 rmsAdBmitt))
(if (> originallength 5) (setq rmsAdBslut6 (linear-to-db (rmsminB urvalslut6))) (setq rmsAdBslut6 rmsAdBmitt))
(if (> originallength 2) (setq rmsAdBslut7 (linear-to-db (rmsminB urvalslut7))) (setq rmsAdBslut7 rmsAdBmitt))
(if (> originallength 2) (setq rmsAdBslut73 (linear-to-db (rmsminB urvalslut73))) (setq rmsAdBslut73 rmsAdBmitt))
(setq rmsAdBslut76 (linear-to-db (rmsminB urvalslut76)))
(setq rmsAdBslut8 (linear-to-db (rmsminB urvalslut8)))
(setq rmsAdBslut9 (linear-to-db (rmsminB urvalslut9)))

(setq senselevel 0)

;Initial känslighet kan vara kritiskt. -8dB krävs för vissa inspelningar, men det kan gå åt skogen.
(if (> (- rmsAdBstart9 rmsAdBmitt) -10) (setq starttid 0)
   (progn
   (setq starttid 0.20)
   (if (< (- rmsAdBstart8 rmsAdBmitt) senselevel)  
      (progn
      (setq starttid 0.30)
      (if (< (- rmsAdBstart76 rmsAdBmitt) senselevel)  
         (progn
         (setq starttid 0.40)
         (if (< (- rmsAdBstart73 rmsAdBmitt) senselevel)  
            (progn
            (setq starttid 0.50) 
            (if (< (- rmsAdBstart7 rmsAdBmitt) senselevel)  
               (progn
               (setq starttid 0.75) 
               (if (< (- rmsAdBstart6 rmsAdBmitt) senselevel)  
                  (progn
                  (setq starttid 1.00) 
                  (if (< (- rmsAdBstart5 rmsAdBmitt) senselevel)  
                     (progn
                     (setq starttid 1.25) 
                     (if (< (- rmsAdBstart45 rmsAdBmitt) senselevel)  
                        (progn
                        (setq starttid 1.50) 
                        (if (< (- rmsAdBstart4 rmsAdBmitt) senselevel)  
                           (progn
                           (setq starttid 2.00) 
                           (if (< (- rmsAdBstart3 rmsAdBmitt) senselevel)  
                              (progn
                              (setq starttid 2.50) 
                              (if (< (- rmsAdBstart2 rmsAdBmitt) senselevel)  
                                 (progn
                                 (setq starttid 3.00) 
                                 (if (< (- rmsAdBstart1 rmsAdBmitt) senselevel)  
                                    (progn
                                    (setq starttid 4.00) 
                                    (if (< (- rmsAdBstartA rmsAdBmitt) senselevel)  
                                       (progn
                                       (setq starttid 5.00) 
                                       (if (< (- rmsAdBstartB rmsAdBmitt) senselevel)  (setq starttid 6.00))
                                       )
                                    ))
                                 ))
                              ))
                           ))
                        ))
                     ))
                  ))
               ))
            ))
         ))
      ))
   ))
)

;Initial känslighet kan vara kritiskt
(if (> (- rmsAdBslut9 rmsAdBmitt) -10) (setq sluttid 0)
   (progn
   (setq sluttid 0.20)
   (if (< (- rmsAdBslut8 rmsAdBmitt) senselevel)  
      (progn
      (setq sluttid 0.30) 
      (if (< (- rmsAdBslut76 rmsAdBmitt) senselevel)  
         (progn
         (setq sluttid 0.40) 
         (if (< (- rmsAdBslut73 rmsAdBmitt) senselevel)  
            (progn
            (setq sluttid 0.50) 
            (if (< (- rmsAdBslut7 rmsAdBmitt) senselevel)  
               (progn
               (setq sluttid 0.75) 
               (if (< (- rmsAdBslut6 rmsAdBmitt) senselevel)  
                  (progn
                  (setq sluttid 1.00) 
                 (if (< (- rmsAdBslut5 rmsAdBmitt) senselevel)  
                     (progn
                     (setq sluttid 1.25) 
                     (if (< (- rmsAdBslut45 rmsAdBmitt) senselevel)  
                        (progn
                        (setq sluttid 1.50) 
                        (if (< (- rmsAdBslut4 rmsAdBmitt) senselevel)  
                           (progn
                           (setq sluttid 2.00) 
                           (if (< (- rmsAdBslut3 rmsAdBmitt) senselevel)  
                              (progn
                              (setq sluttid 2.50) 
                              (if (< (- rmsAdBslut2 rmsAdBmitt) senselevel)  
                                 (progn
                                 (setq sluttid 3.00) 
                                 (if (< (- rmsAdBslut1 rmsAdBmitt) senselevel) 
                                    (progn
                                    (setq sluttid 4.00) 
                                    (if (< (- rmsAdBslutA rmsAdBmitt) senselevel)  
                                       (progn
                                       (setq sluttid 5.00) 
                                       (if (< (- rmsAdBslutB rmsAdBmitt) senselevel)  (setq sluttid 6.00) )
                                       )
                                    ))
                                 ))
                              ))
                           ))
                        ))
                     ))
                  ))
               ))
            ))
         ))
      ))
   ))
)






(setq urvalslutligt (multichan-expand #'extract-abs  (+  originalstarttid starttid)  (-  originalsluttid sluttid)  *track*))



;(setq urval *track*)
;(setq urval (resample urval 384000))
;(setq *sound-srate* 384000)

;ITU486 filtrering. God approximation vid 384ksps.
;Anpassning till 192ksps borde finnas.
(setq urval (hp urvalslutligt 6500 ))
(setq urval (lowpass2 urval 9700))
(setq urval (lowpass4 urval 9700))
;(scale scale sound)
;(scale-db 17 urval)
;(scale-db (+ 17 2.6) urval)
(if (= *sound-srate* 48000)
   (setq urval (scale-db (+ 17 2.6) urval))
;   Inte testat för samplingsfrekvenser <44100Hz, men verkar fungera
   (if (<= *sound-srate* 44100)
      (setq urval (scale-db (+ 17 2.9) urval))
      (if (= *sound-srate* 96000)
         (setq urval (scale-db (+ 17 1.1) urval))
         (setq urval(scale-db (+ 17 0) urval))
      )
   )
)

(format nil "~a~%Mitten:   ~adB ~%5,0-4,0s:  ~adB ~adB ~%4,0-3,0s:  ~adB ~adB ~%2,5-3,0s:  ~adB ~adB ~%2,0-2,5s:  ~adB ~adB ~%1,5-2,0s:  ~adB  ~adB ~%1,25-1,5s:  ~adB  ~adB ~%1,0-1,25s:  ~adB ~adB ~%0,75-1,0s:  ~adB ~adB ~%0,5-0,75s:  ~adB ~adB ~%0,40-0,5s:  ~adB ~adB ~%0,30-0,40s:  ~adB ~adB ~%0,20-0,30s:  ~adB ~adB ~%0,10-0,20s:  ~adB ~adB ~%0,00-0,10s:  ~adB ~adB ~%Början klipps:  ~as~%5,0-4,0s:  ~adB ~adB ~%4,0-3,0s:  ~adB ~adB ~%2,5-3,0s:  ~adB ~adB ~%2,0-2,5s:  ~adB ~adB ~%1,5-2,0s:  ~adB  ~adB ~%1,25-1,5s:  ~adB  ~adB ~%1,0-1,25s:  ~adB ~adB ~%0,75-1,0s:  ~adB ~adB ~%0,5-0,75s:  ~adB ~adB ~%0,40-0,5s:  ~adB ~adB ~%0,30-0,40s:  ~adB ~adB ~%0,20-0,30s:  ~adB ~adB ~%0,10-0,20s:  ~adB ~adB ~%0,00-0,10s:  ~adB ~adB ~%originalsluttid  ~as ~%Slutet klipps:  ~as"

   glapp  
    rmsAdBmitt 
   rmsAdBstartB  (- rmsAdBstartB rmsAdBmitt)
   rmsAdBstartA  (- rmsAdBstartA rmsAdBmitt)
   rmsAdBstart1  (- rmsAdBstart1 rmsAdBmitt)
   rmsAdBstart2  (- rmsAdBstart2 rmsAdBmitt)
   rmsAdBstart3  (- rmsAdBstart3 rmsAdBmitt)
   rmsAdBstart4  (- rmsAdBstart4 rmsAdBmitt)
   rmsAdBstart45  (- rmsAdBstart45 rmsAdBmitt)
   rmsAdBstart5  (- rmsAdBstart5 rmsAdBmitt)
   rmsAdBstart6  (- rmsAdBstart6 rmsAdBmitt)
   rmsAdBstart7  (- rmsAdBstart7 rmsAdBmitt)
   rmsAdBstart3  (- rmsAdBstart73 rmsAdBmitt)
   rmsAdBstart76  (- rmsAdBstart76 rmsAdBmitt)
   rmsAdBstart8  (- rmsAdBstart8 rmsAdBmitt)
   rmsAdBstart9  (- rmsAdBstart9 rmsAdBmitt)
   starttid
   rmsAdBslutB  (- rmsAdBslutB rmsAdBmitt)
   rmsAdBslutA  (- rmsAdBslutA rmsAdBmitt)
   rmsAdBslut1  (- rmsAdBslut1 rmsAdBmitt)
   rmsAdBslut2  (- rmsAdBslut2 rmsAdBmitt)
   rmsAdBslut3  (- rmsAdBslut3 rmsAdBmitt)
   rmsAdBslut4  (- rmsAdBslut4 rmsAdBmitt)
   rmsAdBslut45  (- rmsAdBslut45 rmsAdBmitt)
   rmsAdBslut5  (- rmsAdBslut5 rmsAdBmitt)
   rmsAdBslut6  (- rmsAdBslut6 rmsAdBmitt)
   rmsAdBslut7  (- rmsAdBslut7 rmsAdBmitt)
   rmsAdBslut73  (- rmsAdBslut73 rmsAdBmitt)
   rmsAdBslut76  (- rmsAdBslut76 rmsAdBmitt)
   rmsAdBslut8  (- rmsAdBslut8 rmsAdBmitt)
   rmsAdBslut9  (- rmsAdBslut9 rmsAdBmitt)
   originalsluttid
   sluttid
   )


;(setq urval (resample urval 44100))

;(setq quietest (linear-to-db (rmsmin *track*)))

(setq quietest (linear-to-db (rmsmin urval)))

;Temp. test
;(setq urvalitu486 urval)

(format nil "Minst ~adB~%Samplingshastighet: ~aHz" quietest *sound-srate*)

;(setq *sound-srate* 44100)
;(setq urval (resample urval 44100))

;ISO226 @ 80phon filtrering. God approximation vid 384ksps.

(setq urval (hp urvalslutligt 220 ))
(setq urval (hp urval 220 ))
(if (> *sound-srate* 31000)
   (progn
      (setq urval (lowpass8 urval 15500))
      (setq urval (lowpass8 urval 15500))
   )
)
(setq urval (eq-band urval 80 4 2.5 ))
(setq urval (eq-band urval 800 3 2 ))
(setq urval (eq-band urval 1600 -8 1 ))
(setq urval (eq-band urval 3000 8 2.2 ))
(setq urval (eq-band urval 8900 -14 1.4 ))
;(setq urval (eq-band urval 19000 12 0.7 ))

(if (> *sound-srate* 38000)
   (if (= *sound-srate* 48000)
      (setq urval (eq-band urval 19000 5 0.7 ))
      (if (= *sound-srate* 44100)
         (setq urval (eq-band urval 19000 5 0.7 ))
         (if (= *sound-srate* 96000)
            (setq urval (eq-band urval 19000 12 0.7 ))
            (setq urval (eq-band urval 19000 12 0.7 ))
         )
      )
   )
)

;Nedan verkar inte alls behövas
(if (= *sound-srate* 48000)
   (setq urval (scale-db 0 urval))
   (if (= *sound-srate* 44100)
      (setq urval (scale-db 0 urval))
      (if (= *sound-srate* 96000)
         (setq urval (scale-db 0 urval))
         (setq urval (scale-db 0 urval))
      )
   )
)

;(setq loudest (linear-to-db (rmsmax *track*)))

;(setq loudest (linear-to-db (rmsmax urval)))
(setq loudest (- (linear-to-db (amplitudmax2 urval)) 3))

(if (> (- loudest quietest) 49.5) (setq kvalitet "A")
   (if (> (- loudest quietest) 34.5) (setq kvalitet "B")
      (if (> (- loudest quietest) 19.5) (setq kvalitet "C")
         (setq kvalitet "D-E")
      )
   )
)  

(setf *float-format* "%.2f")

(if (= starttid 6) (setq maxstarttid "(max)") (setq maxstarttid "")) 
(if (= sluttid 6) (setq maxsluttid "(max)") (setq maxsluttid "")) 



;******************** Början på resultatutskrift till fil


(setq snr (round (- loudest quietest)))
;(setq snr 444)
(setf filnamn (get '*TRACK* 'NAME))
(if (> (length filnamn) 15)
   (setf track-name (subseq filnamn 0 15))
   (setf track-name  filnamn))


(setq hemma (get '*system-dir* 'home)) ;Hämtar hemmamappen
(if (= glapp 1)
   (setq uttext (strcat (_ "Pauser med tystnad mitt i filen") "~%" (_ "Ta bort innan mätning") "~%" filnamn "~%"  hemma"~%wSNR v24 txt"))
   (setq uttext (strcat (_ "Ljudkvalitet")  ": " kvalitet "~%"  (_ "SNR") " "  (number-to-string snr) (_ "dB") "(ISO/ITU)~%" (_ "Intoning bortklippt") ": " (number-to-string starttid) "s " maxstarttid "~%" (_ "Uttoning bortklippt") ": " (number-to-string sluttid) "s " maxsluttid "~%" filnamn "~%"  hemma"~%wSNR v24 txt"))
)

(setq hemma (get '*system-dir* 'home)) ;Hämtar hemmamappen

;Omvandlar adressen till hemmamappen från "\"-separerad till "/"-separerad (Windows)
(setq teststring "")
(setq loop 0)
(while (< loop (length hemma))
   (if (= 92 (char-code (char hemma loop)))
   (setq teststring (strcat teststring "/"))
   (setq teststring (strcat teststring (string (char hemma loop)))))
   (setq loop (+ loop 1))
)
(setq teststring (strcat teststring "/"))

; Skriver resulatet till en .txt fil med samma namn som ljudfilen 
 ;     (setf myfile (strcat "C:/Users/ulfel/Documents/Audacity/macro-output/" track-name " SNR " (number-to-string snr) "dB(ISOITU).txt"))
(if (= glapp 1)
       (setf myfile (strcat  teststring track-name " SNR --dB(ISOITU).txt"))
       (setf myfile (strcat  teststring track-name " SNR " (number-to-string snr) "dB(ISOITU).txt"))
)
;      (setf myfile (strcat "C:/Users/ulfel/" track-name " SNR " (number-to-string snr) "dB(ISOITU).txt"))
      (setf fp (open myfile :direction :output))
      (format fp uttext)
      (close fp)
      ""
;******************** Slut på resultatutskrift till fil

;******************** Början på resultat presenteras i Audacity

(if (= glapp 1)
   (format nil "~a~%~%~a ~%~adB " (_ "Pauser med tystnad mitt i filen") (_ "Ta bort innan mätning") rmsurvalglapp)
   (progn
      (if (= glapp 0) (setq glapptext "Inga pauser med tystnad mitt i filen") (setq glapptext "Pauser med tystnad mitt i filen ej utvärderat")) 
      (format nil "~a ~a~%~%~a ~a~a(ISO/ITU)  (~adB)~%~%~a ~as ~a~%~a ~as ~a~%~%Störst ~adB(ISO)~%Minst ~adB(ITU)~%Samplingshastighet: ~aHz~%~a~%Språk ~a" (_ "Ljudkvalitet")  kvalitet  (_ "SNR") (round (- loudest quietest)) (_ "dB") (- loudest quietest)  (_ "Intoning bortklippt") starttid maxstarttid (_ "Uttoning bortklippt") sluttid maxsluttid loudest quietest *sound-srate*  glapptext (get '*audacity* 'language))
   )
)


(if (= glapp 1)
   (format nil "~a~%~%~a ~%~a dB " (_ "Pauser med tystnad mitt i filen") (_ "Ta bort innan mätning") rmsurvalglapp)
   (progn
      (if (= glapp 0) (setq glapptext "Inga pauser med tystnad mitt i filen") (setq glapptext "Pauser med tystnad mitt i filen ej utvärderat")) 
      (format nil "~a ~a~%~%~a ~a~a(ISO/ITU) ~%~%~a ~as ~a~%~a ~as ~a~%~%" (_ "Ljudkvalitet")  kvalitet  (_ "SNR") (round (- loudest quietest)) (_ "dB") (_ "Intoning bortklippt") starttid maxstarttid (_ "Uttoning bortklippt") sluttid maxsluttid)
   )
)

;******************** Slut på resultat presenteras i Audacity